#include "DictHandler.h"

#include <iostream>
#include <qregexp.h>

#include "Structure/CharData.h"

using namespace std;

DictHandler::DictHandler(Dictionary& aDict)
	: theDict(aDict), State(Neutral)
{
}

bool DictHandler::startElement(const QString& namespaceURI, const QString & localName, 
		const QString & qName, const QXmlAttributes & atts)
{
	if ( (State == Neutral) && (qName == "message") )
	{
		State = Message;
		OriginalS = "";
		TranslationS = "";
	}
	else if ( (State == Message) && (qName == "original") )
		State = Original;
	else if ( (State == Message) && (qName == "translation") )
		State = Translation;
	else
		State = Neutral;
	return true;
}

bool DictHandler::endElement(const QString & namespaceURI, const QString & localName, 
		const QString & qName)
{
	if ( (State == Message) && (qName == "message") )
	{
		std::cout << (const char*) OriginalS << std::endl
			<< (const char*) TranslationS << std::endl;
		theDict.add(OriginalS, TranslationS);
		State = Neutral;
	}
	else if ( (State == Original) && (qName == "original") )
		State = Message;
	else if ( (State == Translation) && (qName == "translation") )
		State = Message;
	else
		State = Neutral;
	return true;
}

bool DictHandler::characters(const QString& ch)
{
	QString s(ch);
	s.replace( QRegExp("\\n")," ");
	s.replace( QRegExp("\\r")," ");
	s.replace( QRegExp("\\t")," ");
	s.replace( QRegExp("^ +"),"");
	s.replace( QRegExp(" +$"),"");
	s.replace( QRegExp(" {2,}")," ");
	if (State == Original)
		OriginalS = s;
	else if (State == Translation)
		TranslationS = s;
	return true;
}
