#include "DocBookHandler.h"

#include <iostream>

#include <qregexp.h>

#include "Structure/CharData.h"

DocBookHandler::DocBookHandler()
	: Book(0)
{
}

bool DocBookHandler::startElement(const QString& namespaceURI, const QString & localName, 
		const QString & qName, const QXmlAttributes & atts)
{
	Tag* Open = new Tag(qName);
	if (!Book)
		Book = Open;
	else
		Stack[Stack.size()-1]->add(Open);
	Stack.push_back(Open);
	return true;
}

bool DocBookHandler::endElement(const QString & namespaceURI, const QString & localName, 
		const QString & qName)
{
	Stack.pop_back();
	return true;
}

bool DocBookHandler::characters(const QString& ch)
{
	if (Stack.size() > 0)
	{
		QString s(ch);
		s.replace( QRegExp("\\n")," ");
		s.replace( QRegExp("\\r")," ");
		s.replace( QRegExp("\\t")," ");
		s.replace( QRegExp(" +$"),"");
		s.replace( QRegExp("^ +"),"");
		s.replace( QRegExp(" {2,}")," ");
		if ( (s != "") && (s != " ") )
			Stack[Stack.size()-1]->add(new CharData(s));
	}
	return true;
}
