#ifndef CHARDATA_3E01FE5B12DE61EE_H_
#define CHARDATA_3E01FE5B12DE61EE_H_

#include <vector>

#include <qstring.h>

class QFontMetrics;

#include "Element.h"

class CharData : public Element
{
	public:
		CharData(const QString& aContent);
		CharData(const CharData& anOther);
		virtual ~CharData();

		CharData& operator=(const CharData& anOther);
		virtual CharData* copy() const;

		virtual unsigned int updateHeightToWidth(const QFontMetrics& M, unsigned int aWidth, unsigned int aStart);
		virtual QString contentFromLine(unsigned int aLine, unsigned int Translation);
		virtual Element* elementFromLine(unsigned int aLine);

		QString original() const;
		QString translation() const;	
		void setTranslation(const QString& aText);
		void acceptTranslation(bool anAccept);

		virtual Element* next();
		virtual Element* first();

		virtual void save(std::ostream& File, const QString& Ident);
      virtual void use(const Dictionary& aDict);

	private:
		void wrapWords(const QFontMetrics& M, unsigned int aWidth, const QString& Source,
				std::vector<QString>& Target);

		QString Content;
		std::vector<QString> AsLines;
		QString Translation;
		std::vector<QString> TranslationAsLines;
};

#endif

