#ifndef ELEMENT_3E0117235DB4F836_H_
#define ELEMENT_3E0117235DB4F836_H_

#include <qstring.h>

#include <fstream>

class QFontMetrics;

class Dictionary;
class Tag;

class Element
{
	public:
		Element();
		Element(const Element& anOther);
		virtual ~Element();

		Element& operator=(const Element& anOther);

		virtual Element* copy() const = 0;

		virtual unsigned int updateHeightToWidth(const QFontMetrics& M, 
				unsigned int aWidth, unsigned int aStart) = 0;
		unsigned int height() const;
		unsigned int start() const;
		unsigned int stop() const;
		unsigned int depth() const;

		void setParent(Tag* aParent);
		Tag* parent();
		const Tag* parent() const;

		virtual QString contentFromLine(unsigned int aLine, unsigned int Translation) = 0;
		virtual Element* elementFromLine(unsigned int aLine) = 0;

		bool isTranslationAccepted() const;

		virtual Element* next() = 0;
		virtual Element* first() = 0;

		virtual void save(std::ostream& File, const QString& Ident) = 0;
		virtual void use(const Dictionary& aDict) = 0;

	protected:
		unsigned int Height;
		unsigned int Start;
		Tag* Parent;
		bool TranslationAccepted;
};

#endif

