#ifndef TAG_3E0117292D4C4EBB_H_
#define TAG_3E0117292D4C4EBB_H_

#include <vector>

#include <qstring.h>

#include "Structure/Element.h"

class Tag : public Element
{
	public:
		Tag(const QString& aName);
		Tag(const Tag& anOther);
		virtual ~Tag();

		Tag& operator=(const Tag& anOther);

		virtual Tag* copy() const;

		const QString& name() const;
		void add(Element* aChild);

		virtual unsigned int updateHeightToWidth(const QFontMetrics& M, unsigned int aWidth, unsigned int aStart);
		virtual QString contentFromLine(unsigned int aLine, unsigned int Translation);
		virtual Element* elementFromLine(unsigned int aLine);

		void updateTranslationAccepted();

		virtual Element* first();
		virtual Element* next();
		virtual Element* next(Element* From);

		virtual void save(std::ostream& File, const QString& Ident);
      virtual void use(const Dictionary& aDict);
	private:
		QString Name;
		std::vector<Element*> Children;
};

#endif

