#ifndef TRANSLATIONVIEW_3E011D927A113065_H_
#define TRANSLATIONVIEW_3E011D927A113065_H_

#include <qscrollview.h>

class QPainter;
class QResizeEvent;
class Element;

#include "Structure/Dictionary.h"

class TranslationView : public QScrollView
{
	Q_OBJECT

	public:
		TranslationView(QWidget* aParent, Element* aRoot);

		virtual void drawContents(QPainter* p, int clipx, int clipy, int clipw, int cliph);

		void setRoot(Element* aRoot);
		Element* root();

	signals:
		void charDataSelected(bool aSelected);
		void charDataChanged(const QString& aText);

	public slots:
		void acceptTranslation();
		void setTranslationText(const QString& aText);
		void translationIsOriginal();
		void saveDictionary(const QString& aText);
		void loadDictionary(const QString& aText);

	protected:
		virtual void resizeEvent(QResizeEvent* anEvent);
		virtual void contentsMousePressEvent(QMouseEvent* anEvent);

	private:
		Element* Root;
		Element* Selected;

		Dictionary theDict;
};

#endif

